## mapcache 1.14.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0...3.29)

project (MapCache C)

include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)

if ("${CMAKE_BUILD_TYPE}" STREQUAL "Debug") 
   add_definitions(-DDEBUG) 
endif () 


set (MAPCACHE_VERSION_MAJOR 1)
set (MAPCACHE_VERSION_MINOR 14)
set (MAPCACHE_VERSION_REVISION 1)

if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
   set(CMAKE_INSTALL_LIBDIR lib)
endif(NOT DEFINED CMAKE_INSTALL_LIBDIR)
if(NOT DEFINED CMAKE_INSTALL_BINDIR)
   set(CMAKE_INSTALL_BINDIR bin)
endif(NOT DEFINED CMAKE_INSTALL_BINDIR)

MATH(EXPR MAPCACHE_IS_DEV_VERSION "1-${MAPCACHE_VERSION_MINOR}%2")
if(MAPCACHE_IS_DEV_VERSION)
  set (MAPCACHE_VERSION_STRING "${MAPCACHE_VERSION_MAJOR}.${MAPCACHE_VERSION_MINOR}.${MAPCACHE_VERSION_REVISION}")
else(MAPCACHE_IS_DEV_VERSION)
  set (MAPCACHE_VERSION_STRING "${MAPCACHE_VERSION_MAJOR}.${MAPCACHE_VERSION_MINOR}dev")
endif(MAPCACHE_IS_DEV_VERSION)
MATH(EXPR MAPCACHE_VERSION_NUM "${MAPCACHE_VERSION_MAJOR}*10000+${MAPCACHE_VERSION_MINOR}*100+${MAPCACHE_VERSION_REVISION}")

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
if (APPLE)
  set(CMAKE_FIND_FRAMEWORK "LAST")
endif (APPLE)

macro( report_optional_not_found component )
  message(SEND_ERROR "${component} library/component/dependency could not be found.
  HINTS:
  - disable ${component} support by adding -DWITH_${component}=0
  - add the ${component} install directory to the CMAKE_PREFIX_PATH variable (-DCMAKE_PREFIX_PATH=\"/path/to/${component}-install-dir;/path/to/other/dirs\"")
endmacro()
macro( report_mandatory_not_found component )
  message(SEND_ERROR "${component} library/component could not be found and is a mandatory dependency
  HINT:
  - add the ${component} install directory to the CMAKE_PREFIX_PATH variable (-DCMAKE_PREFIX_PATH=\"/path/to/${component}-install-dir;/path/to/other/dirs\"")
endmacro()
macro( report_dependency_error component dependency)
  message(SEND_ERROR "${component} support requires ${dependency} support, however ${dependency} support has been disabled.
  HINTS:
  - re-run with -DWITH_${dependency}=1 (or without -DWITH_${dependency}=0)
  - disable ${component} support by adding -DWITH_${component}=0"
  )
endmacro()

check_function_exists("strncasecmp"  HAVE_STRNCASECMP)
check_function_exists("symlink"  HAVE_SYMLINK)
check_function_exists ("timegm" HAVE_TIMEGM)
check_function_exists ("strptime" HAVE_STRPTIME)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
set(CMAKE_SKIP_BUILD_RPATH FALSE)
if(APPLE)
  set(CMAKE_MACOSX_RPATH ON)
endif()
  
set(CMAKE_LINK_INTERFACE_LIBRARY "")

file(GLOB mapcache_SOURCES lib/*.c )
file(GLOB mapcache_HEADERS include/*.h)

add_library(mapcache SHARED ${mapcache_SOURCES} ${mapcache_HEADERS})
set_target_properties(mapcache PROPERTIES
  VERSION ${MAPCACHE_VERSION_STRING}
  SOVERSION 1
)

# Add compiler flags for warnings
if(CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror=declaration-after-statement")
endif()

if(CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror=declaration-after-statement -Wno-comment")
endif()

#options suported by the cmake builder
option(WITH_PIXMAN "Use pixman for SSE optimized image manipulations" ON)
option(WITH_SQLITE "Use sqlite as a cache/dimension backend" ON)
option(WITH_POSTGRESQL "Use PostgreSQL as a dimension backend" OFF)
option(WITH_BERKELEY_DB "Use Berkeley DB as a cache backend" OFF)
option(WITH_LMDB "Use LMDB as a cache backend" OFF)
option(WITH_MEMCACHE "Use memcache as a cache backend (requires recent apr-util)" OFF)
option(WITH_REDIS "Use redis as a cache backend (requires hiredis library)" OFF)
option(WITH_TIFF "Use TIFFs as a cache backend" OFF)
option(WITH_TIFF_WRITE_SUPPORT "Enable (experimental) support for writable TIFF cache backends" OFF)
option(WITH_GEOTIFF "Allow GeoTIFF metadata creation for TIFF cache backends" OFF)
option(WITH_PCRE "Use PCRE for regex tests" OFF)
option(WITH_PCRE2 "Use PCRE2 for regex tests" OFF)
option(WITH_MAPSERVER "Enable (experimental) support for the mapserver library" OFF)
option(WITH_RIAK "Use Riak as a cache backend" OFF)
option(WITH_GDAL "Choose if GDAL raster support should be built in" ON)
option(WITH_MAPCACHE_DETAIL "Build coverage analysis tool for SQLite caches" ON)

find_package(PNG)
if(PNG_FOUND)
  include_directories(${PNG_INCLUDE_DIR})
  target_link_libraries(mapcache ${PNG_LIBRARIES})
else(PNG_FOUND)
  report_mandatory_not_found(PNG)
endif(PNG_FOUND)

find_package(JPEG)
if(JPEG_FOUND)
  include_directories(${JPEG_INCLUDE_DIR})
  target_link_libraries(mapcache ${JPEG_LIBRARY})
else(JPEG_FOUND)
  report_mandatory_not_found(JPEG)
endif(JPEG_FOUND)
   
find_package(CURL)
if(CURL_FOUND)
   include_directories(${CURL_INCLUDE_DIR})
   target_link_libraries(mapcache ${CURL_LIBRARY})
else(CURL_FOUND)
   report_mandatory_not_found(CURL)
endif(CURL_FOUND)

find_package(APR)
if(APR_FOUND)
   include_directories(${APR_INCLUDE_DIR} ${APU_INCLUDE_DIR})
   target_link_libraries(mapcache ${APR_LIBRARY} ${APU_LIBRARY})
   if(DEFINED APR_CPPFLAGS)
     add_definitions("${APR_CPPFLAGS}")
   endif(DEFINED APR_CPPFLAGS)
else(APR_FOUND)
   report_mandatory_not_found(APR)
endif(APR_FOUND)

if(WITH_MEMCACHE)
  include(CheckSymbolExists)
   FIND_PATH(tmp_APU_MEMCACHE_DIR
     NAMES apr_memcache.h
     HINTS ${APU_INCLUDE_DIR}
  )
  if(tmp_APU_MEMCACHE_DIR)
    set(CMAKE_REQUIRED_INCLUDE ${APR_INCLUDE_DIR} ${APU_INCLUDE_DIR})
    set(CMAKE_REQUIRED_LIBRARIES ${APR_LIBRARY} ${APU_LIBRARY})
    check_symbol_exists(apr_memcache_hash "${tmp_APU_MEMCACHE_DIR}/apr_memcache.h" tmp_MEMCACHE_USABLE)
    if(tmp_MEMCACHE_USABLE)
      set(USE_MEMCACHE 1)
    else(tmp_MEMCACHE_USABLE)
      MESSAGE(SEND_ERROR "apr_memcache.h found, but seems too old (missing apr_memcache_hash function)")
      report_optional_not_found(MEMCACHE)
    endif(tmp_MEMCACHE_USABLE)
  else(tmp_APU_MEMCACHE_DIR)
    MESSAGE(SEND_ERROR "apr_memcache.h not found, your apr-util version may be configured without memcache support")
    report_optional_not_found(MEMCACHE)
  endif(tmp_APU_MEMCACHE_DIR)
  
endif(WITH_MEMCACHE)

if(WITH_REDIS)
  find_package(Redis)
  if(HIREDIS_FOUND)
    include_directories(${HIREDIS_INCLUDE_DIR})
    target_link_libraries(mapcache ${HIREDIS_LIBRARIES})
    set (USE_REDIS 1)
  else(HIREDIS_FOUND)
    report_optional_not_found(Redis)
  endif(HIREDIS_FOUND)
endif(WITH_REDIS)

if(WITH_PIXMAN)
  find_package(Pixman)
  if(PIXMAN_FOUND)
    include_directories(${PIXMAN_INCLUDE_DIR})
    target_link_libraries(mapcache ${PIXMAN_LIBRARY})
    set (USE_PIXMAN 1)
  else(PIXMAN_FOUND)
    report_optional_not_found(PIXMAN)
  endif(PIXMAN_FOUND)
endif (WITH_PIXMAN)

if(WITH_GDAL)
  find_package(GDAL)
  if(GDAL_FOUND)
    include_directories(${GDAL_INCLUDE_DIR})
    target_link_libraries(mapcache ${GDAL_LIBRARY})
    set (USE_GDAL 1)
  else(GDAL_FOUND)
    report_optional_not_found(GDAL)
  endif(GDAL_FOUND)
endif(WITH_GDAL)

if(WITH_PCRE)
   find_package(PCRE)
  if(PCRE_FOUND)
    include_directories(${PCRE_INCLUDE_DIR})
    target_link_libraries(mapcache ${PCRE_LIBRARY})
    set (USE_PCRE 1)
    add_definitions(-DPCRE_STATIC) 
  else(PCRE_FOUND)
    report_optional_not_found(PCRE)
  endif(PCRE_FOUND)
endif (WITH_PCRE)

if(WITH_PCRE2)
  find_package(PCRE2)
  if(PCRE2_FOUND)
    include_directories(${PCRE2_INCLUDE_DIR})
    target_link_libraries(mapcache PCRE2::PCRE2-8)
    set (USE_PCRE2 1)
    add_definitions(-DPCRE2_CODE_UNIT_WIDTH=8)
  else(PCRE2_FOUND)
    report_optional_not_found(PCRE2)
  endif(PCRE2_FOUND)
endif (WITH_PCRE2)

if(WITH_SQLITE)
  find_package(SQLITE)
  if(SQLITE_FOUND)
    include_directories(${SQLITE_INCLUDE_DIR})
    target_link_libraries(mapcache ${SQLITE_LIBRARY})
    set (USE_SQLITE 1)
  else(SQLITE_FOUND)
    report_optional_not_found(SQLITE)
  endif(SQLITE_FOUND)
endif (WITH_SQLITE)

if(WITH_POSTGRESQL)
  find_package(PostgreSQL)
  if(PostgreSQL_FOUND)
    include_directories(${PostgreSQL_INCLUDE_DIR})
    target_link_libraries(mapcache ${PostgreSQL_LIBRARY})
    set (USE_POSTGRESQL 1)
  else(POSTGRESQL_FOUND)
    report_optional_not_found(POSTGRESQL)
  endif(PostgreSQL_FOUND)
endif (WITH_POSTGRESQL)

if(WITH_BERKELEY_DB)
  if(NOT BERKELEYDB_FIND_VERSION)
    set(BERKELEYDB_FIND_VERSION "4.6")
  endif(NOT BERKELEYDB_FIND_VERSION)
  find_package(BerkeleyDB)
  if(BERKELEYDB_FOUND)
    include_directories(${BERKELEYDB_INCLUDE_DIR})
    target_link_libraries(mapcache ${BERKELEYDB_LIBRARY})
    set (USE_BDB 1)
  else(BERKELEYDB_FOUND)
    report_optional_not_found(BERKELEY_DB)
  endif(BERKELEYDB_FOUND)
endif (WITH_BERKELEY_DB)

if(WITH_LMDB)
  if(NOT LMDB_FIND_VERSION)
    set(LMDB_FIND_VERSION "0.9.10")
  endif(NOT LMDB_FIND_VERSION)
  find_package(LMDB)
  if(LMDB_FOUND)
    include_directories(${LMDB_INCLUDE_DIR})
    target_link_libraries(mapcache ${LMDB_LIBRARY})
    set(USE_LMDB 1)
  else(LMDB_FOUND)
    report_optional_not_found(LMDB)
  endif(LMDB_FOUND)
endif(WITH_LMDB)

if(WITH_TIFF)
  find_package(TIFF)
  if(TIFF_FOUND)
    include_directories(${TIFF_INCLUDE_DIR})
    target_link_libraries(mapcache ${TIFF_LIBRARY})
    set (USE_TIFF 1)
  else(TIFF_FOUND)
    report_optional_not_found(TIFF)
  endif(TIFF_FOUND)
endif (WITH_TIFF)

if(WITH_TIFF_WRITE_SUPPORT)
  if(USE_TIFF)
    set (USE_TIFF_WRITE 1)
  else(USE_TIFF)
    report_dependency_error(TIFF_WRITE_SUPPORT TIFF)
  endif(USE_TIFF)
endif(WITH_TIFF_WRITE_SUPPORT)


if(WITH_GEOTIFF)
  find_package(GEOTIFF)
  if(GEOTIFF_FOUND)
    include_directories(${GEOTIFF_INCLUDE_DIR})
    target_link_libraries(mapcache ${GEOTIFF_LIBRARY})
    set (USE_GEOTIFF 1)
  else(GEOTIFF_FOUND)
    report_optional_not_found(GEOTIFF)
  endif(GEOTIFF_FOUND)
endif (WITH_GEOTIFF)

if(WITH_MAPSERVER)
   find_package(MAPSERVER)
  if(MAPSERVER_FOUND)
    include_directories(${MAPSERVER_INCLUDE_DIR})
    target_link_libraries(mapcache ${MAPSERVER_LIBRARY})
    set (USE_MAPSERVER 1)
  else(MAPSERVER_FOUND)
    report_optional_not_found(MAPSERVER)
  endif(MAPSERVER_FOUND)
endif (WITH_MAPSERVER)

if(WITH_RIAK)
  find_package(RIAK)
  if(RIAK_FOUND)
    include_directories(${RIAK_INCLUDE_DIR})
    target_link_libraries(mapcache ${RIAK_LIBRARY})
    set (USE_RIAK 1)
  else(RIAK_FOUND)
    report_optional_not_found(RIAK)
  endif(RIAK_FOUND)
endif (WITH_RIAK)

if(UNIX)
target_link_libraries(mapcache ${CMAKE_DL_LIBS} m )
endif(UNIX)

configure_file (
  "${PROJECT_SOURCE_DIR}/include/mapcache-config.h.in"
  "${PROJECT_BINARY_DIR}/include/mapcache-config.h"
  )

configure_file (
  "${PROJECT_SOURCE_DIR}/include/mapcache-version.h.in"
  "${PROJECT_BINARY_DIR}/include/mapcache-version.h"
  )

include_directories(include ${PROJECT_BINARY_DIR}/include)

macro(status_optional_component component enabled libpath)
  if("${enabled}" EQUAL "1")
    message(STATUS "  * ${component}: ${libpath}")
  else()
    message(STATUS "  * ${component}: disabled")
  endif()
endmacro()
macro(status_optional_feature feature enabled)
  if("${enabled}" EQUAL "1" OR "${enabled}" STREQUAL "ON")
    message(STATUS "  * ${feature}: ENABLED")
  else()
    message(STATUS "  * ${feature}: disabled")
  endif()
endmacro()

message(STATUS "* Configured options for the mapcache library")
message(STATUS " * Mandatory components")
message(STATUS "  * png: ${PNG_LIBRARY}")
message(STATUS "  * jpeg: ${JPEG_LIBRARY}")
message(STATUS "  * Curl: ${CURL_LIBRARY}")
message(STATUS "  * Apr: ${APR_LIBRARY}")
message(STATUS " * Optional components")
status_optional_component("PIXMAN" "${USE_PIXMAN}" "${PIXMAN_LIBRARY}")
status_optional_component("SQLITE" "${USE_SQLITE}" "${SQLITE_LIBRARY}")
status_optional_component("POSTGRESQL" "${USE_POSTGRESQL}" "${PostgreSQL_LIBRARY}")
status_optional_component("Berkeley DB" "${USE_BDB}" "${BERKELEYDB_LIBRARY}")
status_optional_component("LMDB" "${USE_LMDB}" "${LMDB_LIBRARY}")
status_optional_component("Memcache" "${USE_MEMCACHE}" "${APU_LIBRARY}")

=== apache/CMakeLists.txt ===
option(WITH_VERSION_STRING "Show MapCache in server version string" ON)
option(WITH_APACHE "Build Apache Module" ON)

if(WITH_APACHE)
  add_library(mod_mapcache MODULE mod_mapcache.c)
  set_target_properties(mod_mapcache PROPERTIES PREFIX "")
  target_link_libraries(mod_mapcache mapcache)
  
  find_package(APACHE)
  if(APACHE_FOUND)
     include_directories(${APACHE_INCLUDE_DIR})
     target_link_libraries(mod_mapcache ${APACHE_LIBRARY})
  else(APACHE_FOUND)
     report_mandatory_not_found(APACHE)
  endif(APACHE_FOUND)
  
  if(WITH_VERSION_STRING)
    set(USE_VERSION_STRING 1)
  endif(WITH_VERSION_STRING)
  
  
  
  configure_file (
    "${PROJECT_SOURCE_DIR}/apache/mod_mapcache-config.h.in"
    "${PROJECT_BINARY_DIR}/apache/mod_mapcache-config.h"
    )
  include_directories("${PROJECT_BINARY_DIR}/apache/")
  
  IF(APPLE)
  set_target_properties(mod_mapcache PROPERTIES
             LINK_FLAGS "-Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
  ENDIF(APPLE)

  message(STATUS "* Apache Module support status:")
  status_optional_component("Mapcache Version String" "${USE_VERSION_STRING}" "mod_mapcache/${MAPCACHE_VERSION_STRING}")
  if(APACHE_MODULE_DIR)
     message(STATUS "  * Module will be installed to : ${APACHE_MODULE_DIR}")
  else(APACHE_MODULE_DIR)
     message(WARNING "  * Module will not be automatically installed: module directory not found")
  endif(APACHE_MODULE_DIR)
  
  
  if(APACHE_MODULE_DIR)
    INSTALL(TARGETS mod_mapcache DESTINATION ${APACHE_MODULE_DIR})
  endif(APACHE_MODULE_DIR)
else(WITH_APACHE)
   message(STATUS " * Apache Module support status: DISABLED")
endif(WITH_APACHE)

=== debian/changelog ===
mapcache (1.14.1-3build1) resolute; urgency=medium

  * No-change rebuild for libgdal37.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 30 Oct 2025 20:50:55 +0000

mapcache (1.14.1-3) unstable; urgency=medium

  * Re-enable FCGI support.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Apr 2025 16:51:39 +0200

mapcache (1.14.1-2) unstable; urgency=medium

  * Bump Standards-Version to 4.7.2, no changes.
  * Disable FCGI support. Has problematic license, see: #466117.
    (closes: #1101883)

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 01 Apr 2025 21:21:23 +0200

mapcache (1.14.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.0, no changes.
  * Update copyright file.
  * Drop pcre2.patch, applied upstream.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 02 Aug 2024 16:00:38 +0200

mapcache (1.14.0-4) unstable; urgency=medium

  * Add dpkg-dev (>= 1.22.5) to build dependencies for t64 changes.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 02 Mar 2024 13:01:04 +0100

mapcache (1.14.0-3) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.
    (closes: #1062830)

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 28 Feb 2024 15:45:22 +0100

mapcache (1.14.0-3~exp2) experimental; urgency=medium

  * Add Break/Replaces for renamed -dev package.
    (closes: #1063322)
  * Switch pkg-config build dependency to pkgconf.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 06 Feb 2024 09:19:37 +0100

mapcache (1.14.0-3~exp1) experimental; urgency=medium

  * Add patch to support pcre2.
  * Enable pcre2 support.
  * Use execute_{before,after} instead of override in rules file.
  * Enable Salsa CI.
  * Switch to dh-sequence-*.
  * Drop SOVERSION from -dev package.
  * Drop obsolete rules to move library to multiarch path.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 05 Feb 2024 13:28:58 +0100

mapcache (1.14.0-2.1~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Graham Inggs <ginggs@debian.org>  Sat, 03 Feb 2024 18:41:19 +0000

=== debian/control ===
Source: mapcache
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Alan Boudreault <aboudreault@mapgears.com>,
           Bas Couwenberg <sebastic@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dpkg-dev (>= 1.22.5),
               dh-apache2,
               dh-sequence-apache2,
               dh-sequence-pkgkde-symbolshelper,
               apache2-dev,
               chrpath,
               cmake,
               libcairo2-dev,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libfcgi-dev,
               libfreetype-dev,
               libfribidi-dev,
               libgd-dev,
               libgdal-dev (>= 1.10.0-0~),
               libgeos-dev (>= 3.3.1-1~),
               libharfbuzz-dev,
               libhiredis-dev,
               libjpeg-dev,
               liblmdb-dev,
               libmemcached-dev,
               libpcre2-dev,
               libpixman-1-dev,
               libpng-dev,
               librsvg2-dev,
               libsqlite3-dev,
               libtiff-dev,
               zlib1g-dev,
               pkgconf,
               pkg-kde-tools,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapcache
Vcs-Git: https://salsa.debian.org/debian-gis-team/mapcache.git
Homepage: http://www.mapserver.org/mapcache/
Rules-Requires-Root: no

Package: libmapcache1t64
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Provides: ${t64:Provides}
Breaks: libmapcache1 (<< ${source:Version})
Replaces: libmapcache1
Description: tile caching server - shared library
 This package contains the shared library.
 .
 MapCache is a server that implements tile caching to speed up access to WMS
 layers. The primary objectives are to be fast and easily deployable, while
 offering the essential features (and more!) expected from a tile caching
 solution.

Package: libmapcache-dev
Architecture: any
Section: libdevel
Depends: libmapcache1t64 (= ${binary:Version}),
         ${misc:Depends}
Suggests: mapcache-cgi,
          mapcache-tools,
          libapache2-mod-mapcache
Breaks: libmapcache1-dev (<< 1.14.0-3~)
Replaces: libmapcache1-dev (<< 1.14.0-3~)
Description: tile caching server - shared library development files
 This package contains the development files for the shared library.
 .
 MapCache is a server that implements tile caching to speed up access to WMS
 layers. The primary objectives are to be fast and easily deployable, while
 offering the essential features (and more!) expected from a tile caching
 solution.

Package: mapcache-cgi
Architecture: any
Section: web
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: tile caching server - CGI binary
 This package contains the mapcache FastCGI program, as alternative to the
 Apache module available in libapache2-mod-mapcache.
 .
 MapCache is a server that implements tile caching to speed up access to WMS
 layers. The primary objectives are to be fast and easily deployable, while
 offering the essential features (and more!) expected from a tile caching
 solution.

Package: mapcache-tools
Architecture: any
Section: misc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: tile caching server - tools
 This package provides command-line utilities for MapCache.
 .
 MapCache is a server that implements tile caching to speed up access to WMS
 layers. The primary objectives are to be fast and easily deployable, while
 offering the essential features (and more!) expected from a tile caching
 solution.

Package: libapache2-mod-mapcache
Architecture: any
Section: httpd
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: tile caching server - Apache module
 This is the MapCache module for the Apache web server implementing OGC web
 services. An alternative mapcache FastCGI program is available in
 mapcache-cgi.
 .
 MapCache is a server that implements tile caching to speed up access to WMS
 layers. The primary objectives are to be fast and easily deployable, while
 offering the essential features (and more!) expected from a tile caching
 solution.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Remove buildpath from binaries
export DEB_CFLAGS_MAINT_APPEND=-DNDEBUG

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

CFLAGS+=$(CPPFLAGS)
CFLAGS+=$(LDFLAGS)

include /usr/share/dpkg/pkg-info.mk

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

BUILD_DATE = $(shell LC_ALL=C date -u "+%d %B %Y" -d "@$(SOURCE_DATE_EPOCH)")

MANPAGES := $(wildcard debian/man/*.*.xml)

CMAKE_OPTS:= \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_SKIP_RPATH=ON \
		-DCMAKE_VERBOSE_MAKEFILE=1 \
		-DWITH_APACHE=1 \
		-DWITH_BERKELEY_DB=0 \
		-DWITH_CGI=1 \
		-DWITH_FCGI=1 \
		-DWITH_GEOS=1 \
		-DWITH_GEOTIFF=0 \
		-DWITH_LMDB=1 \
		-DWITH_MAPSERVER=0 \
		-DWITH_OGR=1 \
		-DWITH_PCRE=0 \
		-DWITH_PCRE2=1 \
		-DWITH_PIXMAN=1 \
		-DWITH_REDIS=1 \
		-DWITH_SQLITE=1 \
		-DWITH_TIFF=1 \
		-DWITH_TIFF_WRITE_SUPPORT=0 \
		-DWITH_VERSION_STRING=1

# Disable memcache support on architectures where it's not supported
ifneq (,$(filter $(DEB_BUILD_ARCH),armel armhf i386 mips mipsel powerpc hppa hurd-i386))
	CMAKE_OPTS += -DWITH_MEMCACHE=0
else
	CMAKE_OPTS += -DWITH_MEMCACHE=1
endif

%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTS)

execute_before_dh_auto_build:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man --string-param header-3="$(BUILD_DATE)" $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

execute_after_dh_auto_install:
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/cgi-bin/
	mv $(CURDIR)/debian/tmp/usr/bin/mapcache.fcgi $(CURDIR)/debian/tmp/usr/lib/cgi-bin/mapcache

	# Strip RPATH
	-find $(CURDIR)/debian/tmp/usr/bin -type f -exec chrpath --delete {} \;
	-find $(CURDIR)/debian/tmp/usr/lib -name "*.so*" -type f -exec chrpath --delete {} \;
	-find $(CURDIR)/obj-*/apache -name "*.so*" -type f -exec chrpath --delete {} \;

	# libmapcache-dev headers
	-mkdir -p $(CURDIR)/debian/tmp/usr/include/mapcache/
	install -m 644 $(CURDIR)/include/*.h $(CURDIR)/debian/tmp/usr/include/mapcache/
	install -m 644 $(CURDIR)/obj-*/*/*.h $(CURDIR)/debian/tmp/usr/include/mapcache/

	# Install apache module
	install -d $(CURDIR)/debian/tmp/etc/apache2/mods-available
	install -m 644 $(CURDIR)/debian/mapcache.load $(CURDIR)/debian/tmp/etc/apache2/mods-available

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(UPSTREAM_VERSION)
